## lua-torch-cutorch 0~20170911-g5e9d86c

=== debian/changelog ===
lua-torch-cutorch (0~20170911-g5e9d86c-2) unstable; urgency=medium

  * Add watch file to monitor upstream master branch.
  * Bump Standards-Version to 4.1.4 . (no change)
  * Upload to unstable.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 21 Apr 2018 11:42:38 +0000

lua-torch-cutorch (0~20170911-g5e9d86c-1) experimental; urgency=medium

  * New upstream version 0~20170911-g5e9d86c.
  * Use GCC-6 instead of Clang-3.8 .
  * Point Vcs-* to Salsa.
  * Bump debhelper compat to 11.
  * Fix insecure-copyright-format-uri
  * Remove DEB_HOST_MULTIARCH definition in rules.
  * Bump Standards-Version to 4.1.3 (no change).
  * Update my name.
  * Build with newer lua-torch-torch7 package. (Closes: #870718)

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 27 Jan 2018 06:51:16 +0000

lua-torch-cutorch (0~20170511-g92e9c08-1) experimental; urgency=medium

  * Import upstream snapshot.

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 22 May 2017 04:31:59 +0000

lua-torch-cutorch (0~20170202-g64536bc-1) experimental; urgency=medium

  * Initial release. (Closes: #834040)

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 06 Feb 2017 05:33:38 +0000
